#include <stdio.h>
#include <math.h>
#define DIR "/line9/cat/"
#define minpix 128*128         // use p*.fit minum pixels
// 20131010 add 130911_data's nbad_9?.fit 
#define white 252
#define green 253
#define blue  254
#define red   255

unsigned char  a[513][540],c[513][540];            

double a8[8],b8[8],s8[8],t8[8],aa[4],dd[4], xx[5],yy[5];
double rc,dc,hs2, pi,cx,cy;
double flux,flux1,flux2,flux3,flux4;

int    n1,n2;         
int    ccdno,idate;
int    ix[4],iy[4];
int    ip=0;

char   head[72][80],h[72][80],b[150],f1[50],f2[50],t[50];
char   c0[28],c1[14],c2[14];
FILE   *fp,*fp1,*fp2;

float scale,sky,see;
int   ty;
int  b44[4][4],c44[4][4];

main(int ac, char **av)
{
  int    i,j,k,i1,i2,j1,j2,ij;
  int    p1,p2,q1,q2;
  double q0,x,y,alpha,delta,x1,y1;
  double updec,downdec;
  char   c9=34;              // "
  int    ix0,ix1,iy0,iy1;
  double z0,z1,z2,z3;
  double zx,zy,wx,wy;
  double x0,y0;
  int ijk;
  char color;
  int kk,ido=0;

  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<4){
    printf("\n\t ***** produce c????.gif (131222data) ********\n");
    printf("\n\tUsage:  nq file RA DEC\n\n");
    exit(0);
  }

  scale=0.454;

  strcpy(c1,av[2]);  chs(c1,&rc);       // center of RA
  strcpy(c2,av[3]);  chs(c2,&dc);       //        of Dec
  n1=8640;   n2=8200;

  toms2(rc,c1,1); toms2(dc,c2,0);
  printf("center: %s %s    %d*%d pixels%13.4lf%c scale\n",c1,c2,n1,n2,scale,c9);
  rc*=cx; dc*=cy; a8[6]=rc; a8[7]=dc;  
  hs2=(3600.*180./pi)/scale;                 
  b8[0]=-hs2; b8[1]=b8[2]=0; b8[3]=-b8[0]; b8[4]=(n1+1)/2.; b8[5]=(n2+1)/2.;
  xytoad(b8,a8);

  x=1;     y=n2;     xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
    updec=delta;
  x=n1;    y=1;      xy_rad(rc,dc,x,y,&alpha,&delta,1,0);
  toms2(alpha,c1,1); toms2(delta,c2,0);
  rad_xy(rc,dc,alpha,delta,&x1,&y1,1,0);
    downdec=delta;

  fp1=fopen("/vega2/rhbin/nfits6.pos9","r");
  for(j=0;j<513;j++)for(i=0;i<540;i++)a[j][i]=0;
  for(j=0;j<4;j++)for(i=0;i<4;i++){ b44[j][i]=j*128+100; c44[j][i]=0; }
l10:
  fgets(b,150,fp1); if(feof(fp1))goto l20;
  if(b[0]=='#')goto l10;
  if(b[0]=='*')goto l20;              // if 1st char=='*', end_read
  for(ij=0;ij<80;ij++)if(b[ij]==32)break;
  flux=0.;
  color=1;
  sscanf(&b[ij],"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d %lf %lf %lf %lf %d",
  &aa[1],&dd[1],&aa[0],&dd[0],&aa[2],&dd[2],&aa[3],&dd[3],&sky,&see,&flux,
  &ty,&flux1,&flux2,&flux3,&flux4,&color); 
  if(color>4)color=4;
  if(flux==0.)goto l10;                         // if no usl_cali, ignore
  sscanf(&b[ij-11],"%d",&k); idate=0; if(k>5700)idate=1;
  kk=k;
//if(dc>45.*cy || dc<-12.*cy)goto l10;        // assume data -12 ~~ 45 degree
  if(downdec>dd[2])goto l10;                  // 2012,2,8
  if(  updec<dd[0])goto l10;
  for(i=0;i<4;i++){
    rad_xy(rc,dc,aa[i],dd[i],&x1,&y1,1,0);      // as Schmidt tel.
    xx[i]=x1; yy[i]=y1;
  } xx[4]=xx[0]; yy[4]=yy[0];
  for(i=0;i<4;i++){ ix[i]=xx[i]+0.5; iy[i]=yy[i]+0.5; }
  if(ix[0]>100000 || ix[0]<-100000)goto l10; // 20120902
  i1=ix[0]; if(i1>ix[1])i1=ix[1];
  i2=ix[2]; if(i2<ix[3])i2=ix[3];
  j1=iy[0]; if(j1>iy[3])j1=iy[3];
  j2=iy[1]; if(j2<iy[2])j2=iy[2];
  if(j1<0)j1=0; if(j2>n2-1)j2=n2-1;
  if(i1<0)i1=0; if(i2>n1-1)i2=n1-1;
  if(j2-j1<10 || i2-i1<10)goto l10;   // <10 line overlap, not do
  b[ij]=0; sprintf(t,"%s%s.fit",DIR,b);
  readpfit(t);                //  c[]_work, d[]_shrink_data
  for(j=0;j<513;j++)for(i=0;i<540;i++)c[j][i]=0;
  ijk=0;
  for(j=j1;j<=j2;j+=16)for(i=i1;i<=i2;i+=16){
    x0=i; y0=j;                          
    xy_rad(rc,dc,x0,y0,&alpha,&delta,1,0);           // big ix,iy
    rad_xy(s8[6],s8[7],alpha,delta,&x1,&y1,2,1);     // p*.fit x,y
    x=t8[0]*x1+t8[2]*y1+t8[4];
    y=t8[1]*x1+t8[3]*y1+t8[5];                       
    if(x>=4096 || y>=4032)continue;
    if(x<0 || y <0)continue;
// in /vega2/rhbin/ubandlines.dat,  2010,ccd4, delete 12 0 0 200
    if(idate==0 && ccdno==4)if(x<=2048 || y>=2015 || x>3896)continue;   
    if(color<4)c[j/16][i/16]++;
    ijk+=256;
  } 
  if(ijk<minpix)goto l10;                      // 20130315
  if(kk==6649)ido=1;


  for(j=0;j<513;j++)for(i=0;i<540;i++)if(a[j][i]<250)a[j][i]+=c[j][i];
  ip++; 
//  printf("%2d: %s%9d j:%6d%6d i:%6d%6d color: %d\n",ip,b,ijk,j1,j2,i1,i2,color);
  b[19]=0;
  add_mark(j1,j2,i1,i2,&b[7],color);
  goto l10;
l20:
  fclose(fp1); 
//  tofit("1.fit");
// for(j=252;j<256;j++)for(i=0;i<540;i++)a[j*4-1000][i]=j;
  if(ido){
    sprintf(b,"%s    %s %s",av[1],av[2],av[3]); ptext(150,20,b,4);
    sprintf(b,"%s.gif",av[1]); togif(b,a);
    printf("===>%s\n",b);
  }
}

add_mark(j1,j2,i1,i2,b,color)
int j1,j2,i1,i2; char *b,color;
{
  int i,j,k,ii,jj;
  for(j=0;j<4;j++)for(i=0;i<4;i++){
    jj=j*128*16+64*16; ii=i*135*16+67*16;
    if(j1<jj && jj<j2  && i1<ii && ii<i2){
//    printf("%d %d\n",20+i*135,b44[j][i]);
      ptext(20+i*135,b44[j][i],b,color);
       b44[j][i]-=16; c44[j][i]++;
       if(c44[j][i]%5==0)b44[j][i]+=88;
    }
  }
}


readpfit(t)
char *t;
{
  int i,j,k;
  char f1[60];
  fp=fopen(t,"rb"); if(fp==0){ printf("%s not found!\n",t); exit(0); }
  fread(h,72,80,fp);  fclose(fp);
  k=indexpos(h,"CCD_NO: ",72); sscanf(&h[k][23],"%d",&ccdno);
  k=indexpos(h,"A81     ",72);
  for(i=0;i<8;i++)sscanf(&h[k+i][10],"%le",&s8[i]);
  xytoad(s8,t8);  
} 

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

#define bok  48.
rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3lf",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2lf",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

tofit(char *f1)
{
  int i,j,k;
  for(j=0;j<36;j++)for(i=0;i<80;i++)head[j][i]=32;
  strcpy(&head[ 0][0], "SIMPLE  =                    T ");
  strcpy(&head[ 1][0], "BITPIX  =                    8 ");
  strcpy(&head[ 2][0], "NAXIS   =                    2 ");
  sprintf(&head[3][0], "NAXIS1  =                  540 ");
  sprintf(&head[4][0], "NAXIS2  =                  512 ");
  for(i=0;i<35;i++)if(head[i][0]!=32)head[i][31]='/';
  strcpy(head[35], "END");  head[35][3]=32;
  fp=fopen(f1,"wb"); fwrite(head,36,80,fp);
  fwrite(a,512,540,fp); fclose(fp);
}

#define LWORD unsigned long
#define WORD  unsigned short
#define BYTE  unsigned char

// GIF-parameter
unsigned char SuffixTable[4999], ByteBuf[2592], BlockBuf[256];
short EncodeTable[4999], PrefixTable[4999];      // have in common_use
LWORD TempCode;
short Code, RunBits, ByteCount, ShiftBits;

FillBlockBuf()
{
  TempCode |= (unsigned int)Code << ShiftBits;
  ShiftBits += RunBits;
  while(ShiftBits >= 8)  {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    if(ByteCount == 255){
      BlockBuf[0] = (unsigned char)ByteCount;
      fwrite(BlockBuf, 1, ByteCount+1, fp);
      ByteCount = 0;
    }
    TempCode >>= 8;
    ShiftBits -= 8;
  }
}

togif(char *f1,unsigned char *c)
{
short Encode, MaxCodeSize, Width, Height, Dots, Rows;
short PrefixCode, SuffixCode, RandomIndex, Val;
short head1[7]={0x4947,0x3846,0x6137,0,0,0xf7,0};
short head2[5]={0,0,0,0,0x800};
LWORD jj;
  int i;
  int m1,m2;
  fp=fopen(f1,"wb");
  m2=512; m1=540;
  for(i=0;i<m1*m2;i++)if(c[i] && c[i]<250)c[i]=c[i]*10+60;

  head1[3]=head2[2]=Width=m1;
  head1[4]=head2[3]=Height=m2;
  fwrite(head1,1,13,fp);
  for(i=0;i<253;i++){
    ByteBuf[0]=ByteBuf[1]=ByteBuf[2]=i;
    fwrite(ByteBuf,1,3,fp);
  }
  for(i=0;i<3;i++)ByteBuf[i]=0; ByteBuf[1]=255; fwrite(ByteBuf,1,3,fp);
  for(i=0;i<3;i++)ByteBuf[i]=0; ByteBuf[2]=255; fwrite(ByteBuf,1,3,fp);
  for(i=0;i<3;i++)ByteBuf[i]=0; ByteBuf[0]=255; fwrite(ByteBuf,1,3,fp);
  fputc(0x2c,fp);
  fwrite(head2,2,5,fp);
  ByteCount = ShiftBits = TempCode = 0;

  Encode = 258;  RunBits = 9;  MaxCodeSize =512;
  for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
  Code = 256;
  FillBlockBuf();
  for(Rows = 0; Rows < Height; Rows++)  {
    jj=(m2-1-Rows)*m1;
    for(i=0;i<m1;i++)ByteBuf[i]=c[jj++];
    if(Rows == 0) { PrefixCode = ByteBuf[0];  Dots = 1; }
    else Dots = 0;
    while( Dots < Width)  {
      SuffixCode = ByteBuf[Dots++];
      RandomIndex = PrefixCode ^ (SuffixCode << 4);
      if(RandomIndex == 0)  Val = 1;
      else Val = 4999 - RandomIndex;
      while(1)  {
        if(EncodeTable[RandomIndex] == 0)  {
          Code = PrefixCode;
          FillBlockBuf();
          if(Encode == 4096)  {
            Code = 256;
            FillBlockBuf();
            Encode = 258;  RunBits = 9;  MaxCodeSize =512;
            for(i = 0; i < 4999; i++) EncodeTable[i] = 0;
          }
          else  {
            if(Encode == MaxCodeSize)  {
              MaxCodeSize <<= 1;
              RunBits++;
            }
            PrefixTable[RandomIndex] = PrefixCode;
            SuffixTable[RandomIndex] = (unsigned char)SuffixCode;
            EncodeTable[RandomIndex] = Encode++;
          }
          PrefixCode = SuffixCode;
          break;
        }
        if(PrefixTable[RandomIndex] == PrefixCode &&
           SuffixTable[RandomIndex] == SuffixCode)  {
          PrefixCode = EncodeTable[RandomIndex];
          break;
        }
        else  {
          RandomIndex -= Val;
          if(RandomIndex < 0)  RandomIndex += 4999;
        }
      }
    }
  }
  Code = PrefixCode;
  FillBlockBuf();
  Code = 257;
  FillBlockBuf();
  if(ShiftBits > 0 || ByteCount > 0)   {
    BlockBuf[++ByteCount] = TempCode & 0x00FF;
    BlockBuf[0] = (unsigned char)ByteCount;
    fwrite(BlockBuf, 1, ByteCount+1, fp);
    ByteCount = 0;
  }
  fputc(0, fp);  fputc(';', fp);
  fclose(fp);
}

unsigned char f08[140][7]= {
     {0x00,0x00,0x10,0x38,0x10,0x00,0x00},  /*  0 */
     {0x00,0x00,0x00,0x10,0x00,0x00,0x00},  // pgplot draw marker
     {0x00,0x10,0x10,0x7c,0x10,0x10,0x00},  /*  2  + =43 */
     {0x10,0x54,0x38,0xfe,0x38,0x54,0x10},
     {0x00,0x38,0x44,0x44,0x44,0x38,0x00},
     {0x00,0x44,0x28,0x10,0x28,0x44,0x00},
     {0x00,0x7c,0x44,0x44,0x44,0x7c,0x00},
     {0x00,0x00,0x38,0x38,0x38,0x00,0x00},
     {0x38,0x54,0x92,0xfe,0x92,0x54,0x38},
     {0x38,0x44,0x82,0x92,0x82,0x44,0x38},
     {0x06,0x1a,0x62,0x82,0x62,0x1a,0x06},
     {0x10,0x28,0x44,0x82,0x44,0x28,0x10},
     {0x10,0x38,0x7c,0xfe,0x7c,0x38,0x10},
     {0x82,0x44,0x28,0x10,0x28,0x44,0x82},  /*  13 X =88 */
     {0x38,0x28,0xc6,0x82,0xc6,0x28,0x38},
     {0x38,0x38,0xfe,0xfe,0xfe,0x38,0x38},
     {0x00,0x7c,0x7c,0x7c,0x7c,0x7c,0x00},
     {0x00,0x38,0x7c,0x7c,0x7c,0x38,0x00},
     {0x10,0x54,0x10,0xfe,0x10,0x54,0x10},
     {0xfe,0x82,0x82,0x82,0x82,0x82,0xfe},
     {0x7c,0x82,0x82,0x82,0x82,0x82,0x7c}, /*  20 */
     {0x38,0x44,0x82,0x82,0x82,0x44,0x38},
     {0x00,0x00,0x28,0x10,0x28,0x00,0x00},
     {0x00,0x00,0x10,0x28,0x10,0x00,0x00},
     {0x00,0x00,0x10,0x38,0x10,0x00,0x00},
     {0x10,0x10,0x00,0xc6,0x00,0x10,0x10},
     {0x82,0x44,0x00,0x00,0x00,0x44,0x82},
     {0xc6,0x82,0x00,0x00,0x00,0x82,0xc6},
     {0x10,0x38,0x54,0x10,0x10,0x10,0x10},
     {0x10,0x10,0x10,0x10,0x54,0x38,0x10},
     {0x00,0x20,0x40,0xfe,0x40,0x20,0x00}, /*  30 */
     {0x00,0x08,0x04,0xfe,0x04,0x08,0x00},
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /*  32   */
     {0x00,0x00,0x00,0xFA,0x00,0x00,0x00}, /*  33 ! */
     {0x00,0xE0,0x00,0xE0,0x00,0x00,0x00}, /*  34 " */
     {0x28,0xFE,0x28,0x28,0xFE,0x28,0x00}, /*  35 # */
     {0x20,0x54,0x54,0xFE,0x54,0x54,0x08}, /*  36 $ */
     {0xC2,0xC4,0x08,0x10,0x20,0x46,0x86}, /*  37 % */
     {0x0C,0x72,0x92,0x6A,0x04,0x0A,0x12}, /*  38 & */
     {0x00,0x20,0xC0,0x80,0x00,0x00,0x00}, /*  39 ' */
     {0x00,0x00,0x38,0x44,0x82,0x00,0x00}, /*  40 ( */
     {0x00,0x00,0x82,0x44,0x38,0x00,0x00}, /*  41 ) */
     {0x10,0x54,0x38,0x38,0x54,0x10,0x00}, /*  42 * */
     {0x00,0x10,0x10,0x7C,0x10,0x10,0x00}, /*  43 + */
     {0x00,0x01,0x0E,0x0C,0x00,0x00,0x00}, /*  44 , */
     {0x00,0x10,0x10,0x10,0x10,0x10,0x00}, /*  45 - */
     {0x00,0x00,0x06,0x06,0x00,0x00,0x00}, /*  46 . */
     {0x02,0x04,0x08,0x10,0x20,0x40,0x80}, /*  47 / */
     {0x00,0x7C,0x82,0x82,0x82,0x7C,0x00}, /*  48 0 */
     {0x00,0x00,0x42,0xFE,0x02,0x00,0x00}, /*  49 1 */
     {0x42,0x86,0x8A,0x92,0x92,0x62,0x00}, /*  50 2 */
     {0x44,0x82,0x92,0x92,0x92,0x6C,0x00}, /*  51 3 */
     {0x18,0x28,0x48,0x88,0xFE,0x08,0x00}, /*  52 4 */
     {0xE4,0xA2,0xA2,0xA2,0xA2,0x9C,0x00}, /*  53 5 */
     {0x0C,0x12,0x32,0x52,0x92,0x0C,0x00}, /*  54 6 */
     {0x80,0x86,0x88,0x90,0xA0,0xC0,0x00}, /*  55 7 */
     {0x6C,0x92,0x92,0x92,0x92,0x6C,0x00}, /*  56 8 */
     {0x60,0x92,0x94,0x98,0x90,0x60,0x00}, /*  57 9 */
     {0x00,0x00,0x36,0x36,0x00,0x00,0x00}, /*  58 : */
     {0x00,0x01,0x36,0x34,0x00,0x00,0x00}, /*  59 ; */
     {0x00,0x10,0x28,0x44,0x82,0x00,0x00}, /*  60 < */
     {0x00,0x28,0x28,0x28,0x28,0x28,0x00}, /*  61 = */
     {0x00,0x82,0x44,0x28,0x10,0x00,0x00}, /*  62 > */
     {0x40,0x80,0x8A,0x90,0x90,0x60,0x00}, /*  63 ? */
     {0x40,0x8E,0x92,0x9E,0x82,0x7C,0x00}, /*  64 @ */
     {0x1E,0x28,0x48,0x88,0x48,0x28,0x1E}, /*  65 A */
     {0xFE,0x92,0x92,0x92,0x92,0x6C,0x00}, /*  66 B */
     {0x7C,0x82,0x82,0x82,0x82,0x44,0x00}, /*  67 C */
     {0xFE,0x82,0x82,0x82,0x44,0x38,0x00}, /*  68 D */
     {0xFE,0x92,0x92,0x92,0x92,0x82,0x00}, /*  69 E */
     {0xFE,0x90,0x90,0x90,0x90,0x80,0x00}, /*  70 F */
     {0x7C,0x82,0x82,0x92,0x92,0x5C,0x00}, /*  71 G */
     {0xFE,0x10,0x10,0x10,0x10,0xFE,0x00}, /*  72 H */
     {0x00,0x00,0x82,0xFE,0x82,0x00,0x00}, /*  73 I */
     {0x00,0x04,0x82,0x82,0xFC,0x80,0x00}, /*  74 J */
     {0xFE,0x10,0x10,0x28,0x44,0x82,0x00}, /*  75 K */
     {0xFE,0x02,0x02,0x02,0x02,0x02,0x00}, /*  76 L */
     {0xFE,0x40,0x20,0x10,0x20,0x40,0xFE}, /*  77 M */
     {0xFE,0x40,0x20,0x10,0x08,0x04,0xFE}, /*  78 N */
     {0x7C,0x82,0x82,0x82,0x82,0x7C,0x00}, /*  79 O */
     {0xFE,0x90,0x90,0x90,0x90,0x60,0x00}, /*  80 P */
     {0x7C,0x82,0x82,0x8A,0x84,0x7A,0x00}, /*  81 Q */
     {0xFE,0x90,0x90,0x98,0x94,0x62,0x00}, /*  82 R */
     {0x64,0x92,0x92,0x92,0x92,0x4C,0x00}, /*  83 S */
     {0x80,0x80,0x80,0xFE,0x80,0x80,0x80}, /*  84 T */
     {0xFC,0x02,0x02,0x02,0x02,0xFC,0x00}, /*  85 U */
     {0xF0,0x08,0x04,0x02,0x04,0x08,0xF0}, /*  86 V */
     {0xFC,0x02,0x04,0x18,0x04,0x02,0xFC}, /*  87 W */
     {0x82,0x44,0x28,0x10,0x28,0x44,0x82}, /*  88 X */
     {0x80,0x40,0x20,0x1E,0x20,0x40,0x80}, /*  89 Y */
     {0x82,0x86,0x8A,0x92,0xA2,0xC2,0x00}, /*  90 Z */
     {0x00,0x00,0xFE,0x82,0x82,0x00,0x00}, /*  91 [ */
     {0x80,0x40,0x20,0x10,0x08,0x04,0x02}, /*  92 \ */
     {0x00,0x00,0x82,0x82,0xFE,0x00,0x00}, /*  93 ] */
     {0x00,0x20,0x40,0x80,0x40,0x20,0x00}, /*  94 ^ */
     {0x01,0x01,0x01,0x01,0x01,0x01,0x01}, /*  95 _ */
     {0x00,0x80,0xC0,0x20,0x00,0x00,0x00}, /*  96 ` */
     {0x04,0x2A,0x2A,0x2A,0x1C,0x02,0x00}, /*  97 a */
     {0x00,0xFE,0x12,0x12,0x12,0x0C,0x00}, /*  98 b */
     {0x00,0x1C,0x22,0x22,0x22,0x00,0x00}, /*  99 c */
     {0x00,0x0C,0x12,0x12,0x12,0xFE,0x00}, /* 100 d */
     {0x00,0x1C,0x2A,0x2A,0x2A,0x18,0x00}, /* 101 e */
     {0x00,0x08,0x08,0x3F,0x48,0x48,0x00}, /* 102 f */
     {0x00,0x18,0x25,0x25,0x25,0x1E,0x00}, /* 103 g */
     {0x00,0xFE,0x20,0x20,0x20,0x1E,0x00}, /* 104 h */
     {0x00,0x00,0x00,0x5E,0x00,0x00,0x00}, /* 105 i */
     {0x00,0x02,0x01,0x5E,0x00,0x00,0x00}, /* 106 j */
     {0x00,0xFE,0x10,0x18,0x24,0x42,0x00}, /* 107 k */
     {0x00,0x00,0x80,0xFE,0x00,0x00,0x00}, /* 108 l */
     {0x3E,0x20,0x20,0x3E,0x20,0x20,0x1E}, /* 109 m */
     {0x00,0x3E,0x20,0x20,0x20,0x1E,0x00}, /* 110 n */
     {0x00,0x1C,0x22,0x22,0x22,0x1C,0x00}, /* 111 o */
     {0x00,0x3F,0x24,0x24,0x24,0x18,0x00}, /* 112 p */
     {0x00,0x18,0x24,0x24,0x24,0x3F,0x00}, /* 113 q */
     {0x00,0x20,0x1E,0x20,0x20,0x10,0x00}, /* 114 r */
     {0x10,0x2A,0x2A,0x2A,0x2A,0x04,0x00}, /* 115 s */
     {0x00,0x20,0xFC,0x22,0x22,0x00,0x00}, /* 116 t */
     {0x00,0x3C,0x02,0x02,0x02,0x3E,0x00}, /* 117 u */
     {0x00,0x38,0x04,0x02,0x04,0x38,0x00}, /* 118 v */
     {0x3C,0x02,0x04,0x18,0x04,0x02,0x3C}, /* 119 w */
     {0x00,0x22,0x14,0x08,0x14,0x22,0x00}, /* 120 x */
     {0x21,0x12,0x0C,0x08,0x10,0x20,0x00}, /* 121 y */
     {0x00,0x22,0x26,0x2A,0x32,0x22,0x00}, /* 122 z */
     {0x00,0x00,0x82,0x82,0x6C,0x10,0x00}, /* 123 { */
     {0x00,0x00,0x00,0xFF,0x00,0x00,0x00}, /* 124 | */
     {0x00,0x10,0x6C,0x82,0x82,0x00,0x00}, /* 125 } */
     {0x10,0x20,0x20,0x10,0x08,0x08,0x10}, /* 126 ~ */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 127   */
     {0x00,0xf8,0x40,0x40,0x38,0x00,0x00}, /* 128 h */
     {0xf0,0x80,0x70,0x80,0x70,0x00,0x00}, /* 129 m */
     {0x00,0x48,0xa8,0xa8,0x10,0x00,0x00}, /* 130 s */
     {0x00,0x22,0x22,0xfa,0x22,0x22,0x00}, /* 131 +-*/
     {0x00,0x60,0x90,0x90,0x60,0x00,0x00}, /* 132 o */
     {0x00,0x10,0xe0,0x00,0x00,0x00,0x00}, /* 133 ' */
     {0x10,0xe0,0x10,0xe0,0x00,0x00,0x00}, /* 134 " */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 135   */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 136   */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 137   */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 138   */
     {0x00,0x00,0x00,0x00,0x00,0x00,0x00}, /* 139   */
   };


jf_char(x,y,ic,color)
int x,y; char ic,color;
{
  int i,j,k,ix,iy,jx,jy,m;          
  m=ic & 0xff;   
  for(i=0;i<7;i++){ k=f08[m][i]; if(k==0)continue;
    for(j=-7;j<=0;j++){
      if((k%2)!=0){
        jx=x+i; jy=y+j; 
        a[jy][jx]=color;
      } k=k/2;
    }
  }
}

ptext(x,y,f1,color)
int x,y; char *f1,color;
{
  int i,j,k=x;  
  for(i=0;i<strlen(f1);i++){ jf_char(k,y,f1[i],256-color); k+=7; }
}

